--
-- Vyvojova deska s PIC16F887A a XILINX XC7572XL
--	www.prochazka.zde.cz
--
--	VERZE KODU 1.0.1
--
-- Datum : 6.11.2005
--
--	
-- Demo klavesnice.
-- Led diody 0 az 2 indikuji kod stisknuteho tlacitka ve dvojkove soustave. Pricem dioda LED2 je bit0.
-- Led dioda 4 indikuje signal reset
-- Led dioda 5 je klopny obvod R-S, ktery se ovlada pomoci zeleneho a modreho tlacitka.
--	Led diody 6 a 7 indikuji stisk modreho a zeleneho tlacitka.
--
--
--			DEMO 2
--
--
--
-- DODATEK -> Puvodne bylo zamysleno ze se pouzije IO XILINX XC9572XL. Stim jsem navrhoval i DPS ale 
--  nakonec jsem pouzil XC95144XL. Ten ma nektere funkcni PINy nezapojeny a tudiz je potreba pri
--  pridelovani PINu podivat do schematu vyvojoveho kitu. Nebo do datasheetu XC9572XL. 
--
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity vyvojova_deska_pic_xilinx_montaz is
	PORT (clk : IN  STD_LOGIC;
        reset : IN  STD_LOGIC;
		  sloupce : in std_logic_vector(3 downto 0);
		  radky : out std_logic_vector(1 downto 0);
		  LED7 : out std_logic; 
		  LED6 : out std_logic; 
		  LED5 : out std_logic;
		  LED4 : out std_logic; 
		  TL1 : in std_logic;
		  TL2 : in std_logic;
		  vystup : out std_logic_vector(2 downto 0));

end vyvojova_deska_pic_xilinx_montaz;

architecture Behavioral of vyvojova_deska_pic_xilinx_montaz is

COMPONENT klavesnice
    Port ( sloupce : in std_logic_vector(3 downto 0);
           radky : out std_logic_vector(1 downto 0);
           vystup : out std_logic_vector(2 downto 0);
			  reset : in std_logic;
           clk : in std_logic);
END COMPONENT;

begin
process (clk, reset) begin

	if clk = '1' and clk'event then
			if (TL2 = '0') then			-- R-S obvod
				LED5 <= '1';
     		elsif (TL1 = '0') then
				LED5 <= '0';
    end if;
	end if;

end process;

	LED7 <= TL2;
	LED6 <= TL1;
	LED4 <= reset;
		
modul1: klavesnice PORT MAP(
		sloupce => sloupce,
		radky => radky,
		vystup => vystup,
		reset => reset,
		clk => clk);

end Behavioral;
